
/* ballgameserver.c - a simple UDP server to serve the */
/* BallGame java program. */

/* (C) Mikael Suokas 1998 */

/* compile on solaris with:  */
/*     gcc -Wall -o ballgameserver ballgameserver.c -lsocket */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <stdio.h>
#include <string.h>

#define SERVER_PORT 7887
#define MAX_MESG_SIZE 512

struct sockaddr_in serv_addr, cli_addr;
int sockfd;
u_char mesg[MAX_MESG_SIZE];

int main(int argc, char *argv[])
{
  int n, clilen;
  int x, y, i;
  char *c;

  printf("ballgameserver, version 0.02\n");

  if ((sockfd = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0) {
    perror("Could not create socket: ");
    exit(1);
  }

  c =  (char *) &serv_addr;
  for (i=0; i < sizeof(serv_addr); i++) {
	c[i] = 0;
  }
  serv_addr.sin_family = AF_INET;
  serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
  serv_addr.sin_port = htons(SERVER_PORT);

  if (bind(sockfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0) {
    perror("Could not bind to port");
    exit(1);
  }

  for ( ; ; ) {
    clilen = sizeof(cli_addr);
    n = recvfrom(sockfd, mesg, MAX_MESG_SIZE, 0, (struct sockaddr *) &cli_addr, &clilen);
    if (n < 0) {
      perror("recvfrom error");
      exit(1);
    }

    printf("Received packet ");
    /* Here we do some manipulations on the data in the datagram.. */
    x = (mesg[0] << 8) | mesg[1];
    y = (mesg[2] << 8) | mesg[3];
    printf("[X=%d, Y=%d] ... ", x, y);
    x = 100 + (x - 100) * 0.6;
    y = 100 + (y - 100) * 0.6;
    mesg[0] = (x >> 8);
    mesg[1] = (x & 0xff);
    mesg[2] = (y >> 8);
    mesg[3] = (y & 0xff);
    
    if (sendto(sockfd, mesg, n, 0, (struct sockaddr *) &cli_addr, clilen) != n) {
      perror("sendto error");
      exit(1);
    }
    printf("sent reply [X=%d, Y=%d].\n", x, y);
  }
  
  /* NOTREACHED */
}
