/**
    Copyright (C) 1997 Pekka Nikander & Juha Prssinen.
    All rights Reserved.

    XXX   %Z%%M% version %I% date:%G%

    Module:  TcpipInterfaceEntry (implementation)
    Package: tcpip
    File:    TcpipInterfaceEntry.java


*/
package fi.hut.tcm.jacob.tcpip;
import java.util.Vector;
import java.util.Enumeration;


/**
    TcpipInterfaceEntry
    
    
*/
public class TcpipInterfaceEntry {
    protected String id;
    protected long ethAddr;
    protected int mtu;
    protected Vector ipAddrs;

    public TcpipInterfaceEntry(String id, long ethAddr, int mtu, Vector ipAddrs) {
    //+ TcpipInterfaceEntry::TcpipInterfaceEntry(String, long, int, Vector)
      this.id = new String(id);
      this.ethAddr = ethAddr;
      this.mtu = mtu;
      this.ipAddrs = ipAddrs; // XXX
    //- TcpipInterfaceEntry::TcpipInterfaceEntry(String, long, int, Vector)
    }

    public String getId() {
    //+ TcpipInterfaceEntry::getId( )
      return new String(id);
    //- TcpipInterfaceEntry::getId( )
    }

    public void setId(String id) {
    //+ TcpipInterfaceEntry::setId(String)
      this.id = new String(id);
    //- TcpipInterfaceEntry::setId(String)
    }

    public long getEthAddr() {
    //+ TcpipInterfaceEntry::getEthAddr( )
      return this.ethAddr;
    //- TcpipInterfaceEntry::getEthAddr( )
    }

    public void setEthAddr(long addr) {
    //+ TcpipInterfaceEntry::setEthAddr(long)
      this.ethAddr = addr;
    //- TcpipInterfaceEntry::setEthAddr(long)
    }

    public void setMtu(int mtu) {
    //+ TcpipInterfaceEntry::setMtu(int)
      this.mtu = mtu;
    //- TcpipInterfaceEntry::setMtu(int)
    }

    public int getMtu() {
    //+ TcpipInterfaceEntry::getMtu( )
      return this.mtu;
    //- TcpipInterfaceEntry::getMtu( )
    }

    public void addIpAddr(int addr) {
    //+ TcpipInterfaceEntry::addIpAddr(int)
      ipAddrs.addElement(new Integer(addr));
    //- TcpipInterfaceEntry::addIpAddr(int)
    }

    public Vector getIpAddrs() {
    //+ TcpipInterfaceEntry::getIpAddrs( )
      return (Vector) this.ipAddrs.clone();
    //- TcpipInterfaceEntry::getIpAddrs( )
    }

    public int getDefIpAddr() {
    //+ TcpipInterfaceEntry::getDefIpAddr( )
      return ((Integer) this.ipAddrs.firstElement()).intValue();
    //- TcpipInterfaceEntry::getDefIpAddr( )
    }

    public boolean hasIpAddr(int addr) {
    //+ TcpipInterfaceEntry::hasIpAddr(int)
      Enumeration addrs = ipAddrs.elements();
      while (addrs.hasMoreElements()) {
	if (((Integer) addrs.nextElement()).intValue() == addr) {
	  return true;
	}
      }
      return false;
    //- TcpipInterfaceEntry::hasIpAddr(int)
    }

    public void removeIpAddr(int addr) {
    //+ TcpipInterfaceEntry::removeIpAddr(int)
      Enumeration addrs = ipAddrs.elements();
      while (addrs.hasMoreElements()) {
	Integer ipAddr = (Integer) addrs.nextElement();
	if (ipAddr.intValue() == addr) {
	  ipAddrs.removeElement(ipAddr);
	  return;
	}
      }
    //- TcpipInterfaceEntry::removeIpAddr(int)
    }

    public void print() {
    //+ TcpipInterfaceEntry::print( )
      System.err.println("INTERFACE table entry:");
      System.err.println("Interface id: " + id);
      System.err.println("Ethernet addr: " +
			 Integer.toHexString((int) (ethAddr >> 40)&0xff) +":"+
			 Integer.toHexString((int) (ethAddr >> 32)&0xff) +":"+
			 Integer.toHexString((int) (ethAddr >> 24)&0xff) +":"+
			 Integer.toHexString((int) (ethAddr >> 16)&0xff) +":"+
			 Integer.toHexString((int) (ethAddr >>  8)&0xff) +":"+
			 Integer.toHexString((int) (ethAddr >>  0)&0xff));
      System.err.println("MTU: " + mtu);
      Enumeration addrs = ipAddrs.elements();
      while (addrs.hasMoreElements()) {
	int ipAddr = ((Integer) addrs.nextElement()).intValue();
	System.err.println("IP addr" +": " +
			   (((int) ipAddr >> 24) & 0xff) + "." +
			   (((int) ipAddr >> 16) & 0xff) + "." +
			   (((int) ipAddr >>  8) & 0xff) + "." +
			   (((int) ipAddr >>  0) & 0xff));
      }
    //- TcpipInterfaceEntry::print( )
    }

}; //TcpipInterfaceEntry
