/**
    Copyright (C) 1997 Pekka Nikander & Juha Prssinen.
    All rights Reserved.

    XXX   %Z%%M% version %I% date:%G%

    Module:  UdpStubMessenger (implementation)
    Package: ip
    File:    UdpStubMessenger.java


*/
package fi.hut.tcm.jacob.tcpip;
import fi.hut.tcm.jacob.conduits.*;



/**
  UdpStubMessenger
    
  */
public class UdpStubMessenger
  implements TcpipStubMessenger {

  public static final UdpStubMessenger instance = new UdpStubMessenger();
    
  private UdpStubMessenger() {
  }

  // Should be never called
  public void apply(Message message, State state, Session session) {}

  public void printHeader(Message message) {
    //+ UdpStubMessenger::printHeader(Message)

    BinaryBuffer buffer = message.getBuffer();
    
    // Create header dump with field names
    int srcPort = buffer.getShort(0);
    int destPort = buffer.getShort(2);
    int len = buffer.getShort(4);
    int csum = buffer.getShort(6);
    
    // Print
    System.err.println("SRC PORT: " + srcPort + "  DEST PORT: " + destPort);
    System.err.println("LEN: " + len + "  CSUM: " + csum);
    //- UdpStubMessenger::printHeader(Message)
    }    
}; //UdpStubMessenger

