/**
    Copyright (C) 1997 Pekka Nikander & Juha Prssinen.
    All rights Reserved.

    XXX   %Z%%M% version %I% date:%G%

    Module:  IpHeaderSession (implementation)
    Package: ip
    File:    IpHeaderSession.java


*/
package fi.hut.tcm.jacob.tcpip.ip;
import fi.hut.tcm.jacob.conduits.*;

/**
    IpHeaderSession
    
    Adds an IP header to outgoing packets and sets the 'protocol' field to
    match with the associated higher-level protocol. Removes the IP header
    frame from incoming packets.
*/
public class IpHeaderSession
  extends Session {

    protected int currDatagramId;
    public static int MAX_DATAGRAM_ID = 65535;

    public IpHeaderSession(State initialState) {
    //+ IpHeaderSession::IpHeaderSession(State)
      super(initialState);
      currDatagramId = 1;
    //- IpHeaderSession::IpHeaderSession(State)
    }

    protected int getNextDatagramId() {
    //+ IpHeaderSession::getNextDatagramId( )
      if (currDatagramId >= MAX_DATAGRAM_ID)
	currDatagramId = 0;
      return ++currDatagramId; // note that the value is never 0
    //- IpHeaderSession::getNextDatagramId( )
    }

}; //IpHeaderSession

