/**
    Copyright (C) 1997 Pekka Nikander & Juha Prssinen.
    All rights Reserved.

    XXX   %Z%%M% version %I% date:%G%

    Module:  IpReassemblyToNetMessenger (implementation)
    Package: ip
    File:    IpReassemblyToNetMessenger.java


*/
package fi.hut.tcm.jacob.tcpip.ip;
import fi.hut.tcm.jacob.conduits.*;
import fi.hut.tcm.jacob.tcpip.*;

/**
    IpReassemblyToNetMessenger
    
    A pretty simple messenger; only provides the standard apply() method,
    which calls the State's applyToNet() method.
*/
public class IpReassemblyToNetMessenger
  extends IpMessenger {
    public static IpReassemblyToNetMessenger instance = new IpReassemblyToNetMessenger();

    public void apply(Message message, State state, Session session) {
    //+ IpReassemblyToNetMessenger::apply(Message, State, Session)
      IpReassemblyState st = (IpReassemblyState) state;
      st.applyToNet(message, session, this);
    //- IpReassemblyToNetMessenger::apply(Message, State, Session)
    }

}; //IpReassemblyToNetMessenger

