/**
    Copyright (C) 1997 Pekka Nikander & Juha Prssinen.
    All rights Reserved.

    XXX   %Z%%M% version %I% date:%G%

    Module:  IpRoutingAccessor (implementation)
    Package: ip
    File:    IpRoutingAccessor.java


*/
package fi.hut.tcm.jacob.tcpip.ip;
import fi.hut.tcm.jacob.conduits.*;
import fi.hut.tcm.jacob.tcpip.*;

/**
    IpRoutingAccessor
    
    1. Gets the correct network interface IP address and Ethernet interface
    number from the InterfaceTable.
    2. If the source IP address is empty, the retrieved network interface
    IP address is put as the source IP address.
    3. Finally, the accessor returns the interface key to its mux.
    
*/
public class IpRoutingAccessor
  implements Accessor {

    public IpRoutingAccessor() {
    //+ IpRoutingAccessor::IpRoutingAccessor( )
    //- IpRoutingAccessor::IpRoutingAccessor( )
    }

    public Object getKey(Message message) {
    //+ IpRoutingAccessor::getKey(Message)
      return ((TcpipOutOfBand) message.getOutOfBand()).getInterfaceId();
    //- IpRoutingAccessor::getKey(Message)
    }

    public void setKey(Message message, Object key) {
    //+ IpRoutingAccessor::setKey(Message, Object)
      TcpipOutOfBand oob = (TcpipOutOfBand) message.getOutOfBand();
      oob.setInterfaceId((String) key);
    //- IpRoutingAccessor::setKey(Message, Object)
    }

}; //IpRoutingAccessor
