/**
    Copyright (C) 1997 Pekka Nikander & Juha Prssinen.
    All rights Reserved.

    XXX   %Z%%M% version %I% date:%G%

    Module:  IpRoutingOnState (implementation)
    Package: ip
    File:    IpRoutingOnState.java


*/
package fi.hut.tcm.jacob.tcpip.ip;
import fi.hut.tcm.jacob.conduits.*;

/**
    IpRoutingOnState
    
    The RoutingSession is in this state when routing is enabled.
    
*/
public class IpRoutingOnState
  extends IpRoutingState {

  public static final IpRoutingOnState instance = new IpRoutingOnState();


    /**
        Calls the Messenger's destinationLocal() method which tells if the
        destination IP address belongs to this machine. If the destination
        is local, then the message is forwarded to the ReassemblySession
        right away.
        The IP TimeToLive is decremented by one. If it becomes zero, the
        packet is sent to the IcmpAdaptor.
        The messenger's setNextHopIp() method is called, and the packet is
        sent on its way to  the IpRoutingMux.
        
    */
    public void applyFromNet(Message message, Session session, Messenger messenger) {
    //+ IpRoutingOnState::applyFromNet(Message, Session, Messenger)
      message.setMessenger(IpRoutingToNetMessenger.instance);
      applyToNet(message, session, IpRoutingToNetMessenger.instance); 
    //- IpRoutingOnState::applyFromNet(Message, Session, Messenger)
    }

}; //IpRoutingOnState

