/**
    Copyright (C) 1997 Pekka Nikander & Juha Prssinen.
    All rights Reserved.

    XXX   %Z%%M% version %I% date:%G%

    Module:  IpRoutingSession (implementation)
    Package: ip
    File:    IpRoutingSession.java


*/
package fi.hut.tcm.jacob.tcpip.ip;
import fi.hut.tcm.jacob.conduits.*;
import fi.hut.tcm.jacob.tcpip.*;

/**
    IpRoutingSession
    
    1. For outgoing packets, retrieves the next-hop IP from the
    RoutingTable and puts it in the Out-of-Band data.
    2. Asks the InterfaceTable if the destination IP address is a local one
    (ie belongs to the host). In that case, the IP packet is returned back
    up to the ReassemblySession. Otherwise, the packet is forwarded to the
    RoutingMUX.
    3. For incoming packets, if the destination IP belongs to the host, the
    packet is forwarded to the ReassemblySession.
    4. If the host is not a router and the destination address is not ours,
    the IP packet is possibly forwarded to the ICMPAdaptor, or nuked,
    depending on whether we want to generate an ICMP message or not.
    5. If the host is a router and the destination address is not ours,
    the next-hop IP is retrieved from the RoutingTable
    TTL (Time To Live) is subtracted by one
    if TTL=0, the packet is forwarded to the ICMPAdaptor
    
*/
public class IpRoutingSession
  extends Session {
    protected TcpipRoutingTable routingTable;
    protected TcpipInterfaceTable interfaceTable;

    public IpRoutingSession(State initialState, TcpipRoutingTable routingTable, TcpipInterfaceTable interfaceTable) {
    //+ IpRoutingSession::IpRoutingSession(State, TcpipRoutingTable, TcpipInterfaceTable)
      super(initialState);
      this.routingTable = routingTable;
      this.interfaceTable = interfaceTable;
    //- IpRoutingSession::IpRoutingSession(State, TcpipRoutingTable, TcpipInterfaceTable)
    }

}; //IpRoutingSession

