/**

    File:    IcmpEchoTest.java

    !!!!!!!!HANDMADE!!!!!!!

*/

package fi.hut.tcm.jacob.tcpip.icmp;
import fi.hut.tcm.jacob.conduits.*;
import fi.hut.tcm.jacob.tcpip.*;
/**

  IcmpEchoTest

*/

public class IcmpEchoTest {
  
  // SimpleScheduler automatically starts travellerThread
  private final SimpleScheduler scheduler = SimpleScheduler.instance;
  
  public static void main(String[] argv) {

    if (argv.length != 0) {
      System.err.println("Usage: java IcmpEchoTest");
      System.exit(1);
    }

    IpAddress myAddr = new IpAddress("1.2.3.4");
    int myIpAddr = myAddr.toInt();

    IpAddress otherAddr = new IpAddress("10.0.10.20");
    int otherIpAddr = otherAddr.toInt();

    // Instances

    IcmpEchoSendAdaptor sendAdap =
      new IcmpEchoSendAdaptor();
    IcmpEchoAnswerAdaptor answAdap =
      new IcmpEchoAnswerAdaptor();
    IcmpSelectorAccessor seleAcce =
      new IcmpSelectorAccessor();
    Mux seleMux =
      new Mux(seleAcce);
    Terminator seleMuxTerm =
      new Terminator(); 
    IcmpChecksumSession sumSes = 
      new IcmpChecksumSession(IcmpChecksumState.instance);
    IcmpBounceAdaptor bounAdap =
      new IcmpBounceAdaptor();

    // Define the conduit structure of the system

    try {
      sendAdap.attach(Side.A, seleMux);
      answAdap.attach(Side.A, seleMux);
      
      seleMux.attach(Side.A, sumSes);
      seleMux.attach(Side.B, seleMuxTerm);
      seleMux.attach(new Integer(8), answAdap);
      seleMux.attach(new Integer(0), sendAdap);

      sumSes.attach(Side.A, bounAdap);
      sumSes.attach(Side.B, seleMux);

      bounAdap.attach(Side.A, sumSes);

    } catch (SideException e) {
      System.out.println("Host #" + " failed to initialize");
      System.exit(2);
    }

    int dummy = 2; int seq;
    for (int i = 1; i < 3; i++) {  // ping twice, for now
      seq = (i + 1) * 256 + i;
      System.out.println("Sending ICMP Echo, seq = " + seq);
      sendAdap.send(otherIpAddr, 666, seq);
      for (int j = 0; j < 1000000; j++) { // Sleep can destroy binary buffers...
	dummy = dummy * dummy + 1;
	dummy = dummy / 2;
      }
    }

  }
}







