/**
    Copyright (C) 1997 Pekka Nikander & Juha Prssinen.
    All rights Reserved.

    XXX   %Z%%M% version %I% date:%G%

    Module:  UdpChecksumState (implementation)
    Package: udp
    File:    UdpChecksumState.java


*/
package fi.hut.tcm.jacob.tcpip.udp;
import fi.hut.tcm.jacob.conduits.*;
import fi.hut.tcm.jacob.tcpip.*;

/**
    UdpChecksumState
    
    
*/
public class UdpChecksumState
  implements State {
    public static UdpChecksumState instance = new UdpChecksumState();

    public void applyToNet(Message message, Session session,
			   Messenger messenger) {
    //+ UdpChecksumState::applyToNet(Message, Session, Messenger)
      UdpChecksumToNetMessenger msgr = (UdpChecksumToNetMessenger) messenger;
      TcpipOutOfBand oob = (TcpipOutOfBand) message.getOutOfBand();
      UdpChecksumSession sess = (UdpChecksumSession) session;
      TcpipRoutingTable rtbl = sess.routingTable;
      TcpipInterfaceTable itbl = sess.interfaceTable;

      int destIpAddr = oob.getDestIpAddr();
      TcpipRoutingEntry rentry = rtbl.get(destIpAddr);
      TcpipInterfaceEntry ientry = itbl.get(rentry.getInterfaceId());
      int srcIpAddr = ientry.getDefIpAddr();
      msgr.calculateChecksum(message, srcIpAddr, destIpAddr);
    //- UdpChecksumState::applyToNet(Message, Session, Messenger)
    }

    public void applyFromNet(Message message, Messenger messenger) {
    //+ UdpChecksumState::applyFromNet(Message, Messenger)
      ((UdpChecksumFromNetMessenger) messenger).validChecksum(message);
      message.setMessenger(UdpHeaderFromNetMessenger.instance);
    //- UdpChecksumState::applyFromNet(Message, Messenger)
    }

}; //UdpChecksumState
